﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Turing
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        TuringCore.tcMachine turing;

        public MainWindow()
        {
            InitializeComponent();
        }


        private void debugger(string s)
        {

            output.Items.Add(s);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            output.Items.Clear();

            turing = new TuringCore.tcMachine("*11x1111=*", 0, debugger, ' ');
            turing.addCell(0, '1', "q01→q01R");
            turing.addCell(1, '1', "q11→q2aR");
            turing.addCell(2, '1', "q21→q21L");
            turing.addCell(3, '1', "q31→q4aR");
            turing.addCell(4, '1', "q41→q41R");
            turing.addCell(7, '1', "q71→q2aR");

            turing.addCell(0, 'x', "q0x→q1xR");
            turing.addCell(2, 'x', "q2x→q3xL");
            turing.addCell(4, 'x', "q4x→q4xR");
            turing.addCell(6, 'x', "q6x→q7xR");
            turing.addCell(8, 'x', "q8x→q9xN");

            turing.addCell(2, '=', "q2=→q2=L");
            turing.addCell(4, '=', "q4=→q4=R");
            turing.addCell(7, '=', "q7=→q8=L");

            turing.addCell(2, 'a', "q2a→q2aL");
            turing.addCell(3, 'a', "q3a→q3aL");
            turing.addCell(4, 'a', "q4a→q4aR");
            turing.addCell(6, 'a', "q6a→q61R");
            turing.addCell(7, 'a', "q7a→q7aR");
            turing.addCell(8, 'a', "q8a→q81L");

            turing.addCell(0, '*', "q0*→q0*R");
            turing.addCell(3, '*', "q3*→q6*R");
            turing.addCell(4, '*', "q4*→q51R");

            turing.addCell(5, ' ', "q5 →q2*L");

            while (turing.Step())
                output.Items.Add(string.Format("Result = {0}", turing.Result));


        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {

            output.Items.Clear();

            Int32 op1, op2;

            turing = new TuringCore.tcMachine(String.Format("*{0}x{1}=*", new String('1', op1 = Convert.ToInt32(op1Box.Text)), new String('1', op2 = Convert.ToInt32(op2Box.Text))), 0, null, ' ');

            turing.addCell(0, '1', "q01→q01R");
            turing.addCell(0, 'x', "q0x→q1xR");
            turing.addCell(0, '*', "q0*→q0*R");

            turing.addCell(1, '1', "q11→q2aR");

            turing.addCell(2, '1', "q21→q21L");
            turing.addCell(2, 'x', "q2x→q3xL");
            turing.addCell(2, '=', "q2=→q2=L");
            turing.addCell(2, 'a', "q2a→q2aL");

            turing.addCell(3, '1', "q31→q4aR");
            turing.addCell(3, 'a', "q3a→q3aL");
            turing.addCell(3, '*', "q3*→q6*R");

            turing.addCell(4, '1', "q41→q41R");
            turing.addCell(4, 'x', "q4x→q4xR");
            turing.addCell(4, 'a', "q4a→q4aR");
            turing.addCell(4, '*', "q4*→q51R");
            turing.addCell(4, '=', "q4=→q4=R");

            turing.addCell(5, ' ', "q5 →q2*L");

            turing.addCell(6, 'x', "q6x→q7xR");
            turing.addCell(6, 'a', "q6a→q61R");

            turing.addCell(7, '1', "q71→q2aR");
            turing.addCell(7, '=', "q7=→q8=L");
            turing.addCell(7, 'a', "q7a→q7aR");


            turing.addCell(8, 'x', "q8x→q9xN");
            turing.addCell(8, 'a', "q8a→q81L");








            DateTime timeStart = DateTime.Now;
            while (turing.Step())
            {
                //   output.Items.Add(string.Format("Result = {0}", turing.Result));
            }

            DateTime timeEnd = DateTime.Now;

            TimeSpan timeDiff = timeEnd.Subtract(timeStart);

            output.Items.Add(string.Format("Total time: {0}", timeDiff));


            string s = turing.Result.ToString();


            Int32 result = s.Split('=')[1].Length - 1;

            output.Items.Add(string.Format("Result of {1} x {2} = {0}", result, op1, op2));
            output.Items.Add(string.Format("Total steps: {0}", turing.stepCounter));
            output.Items.Add(string.Format("Is result correct: {0}", op1 * op2 == result));




        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            output.Items.Clear();

            Int32 op1, op2;

            turing = new TuringCore.tcMachine(String.Format("{0}*{1}", new String('1', op1 = Convert.ToInt32(op1Box.Text)), new String('1', op2 = Convert.ToInt32(op2Box.Text))), 0, null, ' ');

            turing.addCell(0, '1', "q01→q10R");
            turing.addCell(0, '*', "q0*→q0*R");
            turing.addCell(0, '=', "q0=→q4=L");

            turing.addCell(1, '1', "q11→q11R");
            turing.addCell(1, '*', "q1*→q1*R");
            turing.addCell(1, '=', "q1=→q2=R");
            turing.addCell(1, ' ', "q1 →q2=R");

            turing.addCell(2, '1', "q21→q21R");
            turing.addCell(2, ' ', "q2 →q31L");

            turing.addCell(3, '1', "q31→q31L");
            turing.addCell(3, '0', "q30→q00R");
            turing.addCell(3, '*', "q3*→q3*L");
            turing.addCell(3, '=', "q3=→q3=L");

            turing.addCell(4, '0', "q40→q41L");
            turing.addCell(4, '*', "q4*→q4*L");
            turing.addCell(4, ' ', "q4 →q5 R");

            turing.addCell(5, '1', "q51→q61N");

            DateTime timeStart = DateTime.Now;
            while (turing.Step())
            {
                //        output.Items.Add(string.Format("Result = '{0}'", turing.Result));
            }

            DateTime timeEnd = DateTime.Now;

            TimeSpan timeDiff = timeEnd.Subtract(timeStart);

            output.Items.Add(string.Format("Total time: {0}", timeDiff));


            string s = turing.Result.ToString();


            Int32 result = s.Split('=')[1].Length;

            output.Items.Add(string.Format("Result of {1} + {2} = {0}", result, op1, op2));
            output.Items.Add(string.Format("Total steps: {0}", turing.stepCounter));
            output.Items.Add(string.Format("Is result correct: {0}", op1 + op2 == result));

        }
    }
}
